/******************************************************************
*
*	CyberUPnP for Java
*
*	Copyright (C) Satoshi Konno 2002-2003
*
*	File: HTTPServerList.java
*
*	Revision;
*
*	05/08/03
*		- first revision.
*
******************************************************************/

package org.cybergarage.http;

import java.util.*;

import org.cybergarage.net.*;

public class HTTPServerList extends Vector 
{
	////////////////////////////////////////////////
	//	Constructor
	////////////////////////////////////////////////
	
	public HTTPServerList() 
	{
	}

	////////////////////////////////////////////////
	//	Methods
	////////////////////////////////////////////////

	public void addRequestListener(HTTPRequestListener listener)
	{
		int nServers = size();
		for (int n=0; n<nServers; n++) {
			HTTPServer server = getHTTPServer(n);
			server.addRequestListener(listener);
		}
	}		
	
	public HTTPServer getHTTPServer(int n)
	{
		return (HTTPServer)get(n);
	}

	////////////////////////////////////////////////
	//	open/close
	////////////////////////////////////////////////

	public void close()
	{
		int nServers = size();
		for (int n=0; n<nServers; n++) {
			HTTPServer server = getHTTPServer(n);
			server.close();
		}
	}


/*
	HTTPServerList.open1:
	HTTPServerList.open2: 4
	HTTPServerList.open3: 0
	HTTPServerList.open4: fe80:0:0:0:211:95ff:fe91:9ae6
	HTTPServerList.open5:
	HTTPServerList.open5a: fe80:0:0:0:211:95ff:fe91:9ae6 8066
*/	

	public boolean open(int port) 
	{
	System.out.println("HTTPServerList.open1: ");
		int nHostAddrs = HostInterface.getNHostAddresses();
	System.out.println("HTTPServerList.open2: "+nHostAddrs);
		for (int n=0; n<nHostAddrs; n++) {
	System.out.println("HTTPServerList.open3: "+n);
			String bindAddr = HostInterface.getHostAddress(n);
	System.out.println("HTTPServerList.open4: "+bindAddr);
			HTTPServer httpServer = new HTTPServer();
	System.out.println("HTTPServerList.open5: ");
			if (httpServer.open(bindAddr, port) == false) {
	System.out.println("HTTPServerList.open5a: "+bindAddr+" "+port);
				close();
				clear();
				return false;
			}
	System.out.println("HTTPServerList.open6: ");
			add(httpServer);
	System.out.println("HTTPServerList.open7: ");
		}
		return true;
	}
	
	////////////////////////////////////////////////
	//	start/stop
	////////////////////////////////////////////////
	
	public void start()
	{
		int nServers = size();
		for (int n=0; n<nServers; n++) {
			HTTPServer server = getHTTPServer(n);
			server.start();
		}
	}

	public void stop()
	{
		int nServers = size();
		for (int n=0; n<nServers; n++) {
			HTTPServer server = getHTTPServer(n);
			server.stop();
		}
	}

}

